//#include	<string.h>	// strcpy
#include	<stdlib.h>	// NULL
#include	<iostream.h>	// cout
#include	<ctype.h>	// toupper

#include "CRC32.h"
#include "AddFile.h"
#include "WriteBlk.h"

typedef unsigned char byte;

typedef struct FILE_TREE
{	short unsigned	nDir;
	byte	balance, cmpres;
	struct FILE_TREE	*RLINK, *LLINK;
	unsigned long	Key;
	DirGrp*	pDirGrp;
}	FileT;

typedef struct UNWANTED_FILES_MASK
{	struct UNWANTED_FILES_MASK* Next;
	char	Mask[1];
}	UFM;

//-----------------------------------------------------------------------------
extern short unsigned	nDir;

UFM* UnwantedFilesList = NULL;
void* FileListHead;
unsigned	long nFile;
DirGrp	*GrpFirst,*GrpLast;
short	unsigned nGrp;

//-----------------------------------------------------------------------------
#define	pLink(p,b)	(FileT**)(void*)((char*)(p)+(b))
#define	Link(p,b)	*pLink(p,b)
#define	Neg(x)	(x^12)
#define	B(x)	((x)->balance)
#define	A(x)	((x)->cmpres)
#define	N	((FileT*)New)

void* file_insert( void* New )
{
	FileT	*P, *Q, *R, *S, **T, **W;
	unsigned	a;

// A1
	P = S = *(T = (FileT**)&FileListHead);
//	A5
	N->LLINK = N->RLINK = NULL;
	B(N) = 0;
	if( P )	goto A2;
// p  ᨬ p
	*T = N;
	return NULL;
	
A3:if( B(Q) )
	{	T = W; S = Q; }
	P = Q;
A2:
	if( N->Key == P->Key )	return P;
	A(P) = (byte)( a = ( N->Key < P->Key ? 8 : 4 ) );
	if( Q = *(W = pLink(P,a)), Q )	goto A3;
	*W = Q = N;
// A6
	R = P = Link( S, A(S) );
	while( P!=Q )
		P =Link( P, B(P) = A(P) );
// A7
	if( ( a = A(S) ) != B(S) )
	{	B(S) = (byte)( B(S) ? 0 : (byte)a );
		return NULL;
	}
	if( B(R) == a )
	{	// A8
		P = R;
		B(R) = B(S) = 0;
		Link( S, a ) = *(W = pLink( R, Neg(a) ));
		*W = S;
	}else
	{	// A9
		P = *(W = pLink( R, Neg(a) ));
		*W = Link( P, a );
		Link( P, a ) = R;
		Link( S, a ) = *(W = pLink( P, Neg(a) ));
		*W = S;
		if( !B(P) )
		{	B(S) = B(R) = 0;
		}else if( B(P) == a )
		{	B(S) = (byte)Neg(a); B(R) = 0;
		}else
		{	B(S) = 0; B(R) = (byte)a;
		}
		B(P)=0;
	}
// A10
	*T = P;
	return NULL;
}

// 뢮  䠩.
int	WriteTreeToFile( const char* FileName )
{	int	rc;
	FileT*	prev;
	FileT*	cur;
	FileT*	next;

	if( !FileListHead )
	{	cout << "Nothing to do\n";
		return	1;
	}
	if( rc = BeforeWriteItems( nFile, nGrp, FileName ), rc )	return rc;
	prev = NULL;
	cur = (FileT*)FileListHead;
GoLeft:
	while ( next = cur->LLINK, next )
	{	cur->cmpres = (byte)8;
		cur->LLINK = prev;
		prev = cur;
		cur = next;
	}
Treate:
	if( cur->nDir )	// p᪠ ⥫ 䠩
	{	if( rc = WriteItem( cur->Key, (cur->pDirGrp) ? (cur->pDirGrp)->nDir : cur-> nDir ), rc )
		{	cout << "rc=" << rc << '\n';
			AfterWriteItems();
			return rc;
		}
	}
	if( next = cur->RLINK, next )
	{	cur->cmpres = (byte)4;
		cur->RLINK = prev;
		prev = cur;
		cur = next;
		goto	GoLeft;
	}
	do
	{	next = cur;
		if( cur=prev, !cur )	return AfterWriteItems();
		prev = Link(cur,A(cur));
		Link(cur,A(cur)) = next;
	}while( cur->cmpres == (byte)4 );
	goto	Treate;
}

//-----------------------------------------------------------------------------
int MaskCmp(char *mask, char *name)
{	int	c;
	while(*mask && *name)
	{	switch(*mask)
		{
		case '?':
			mask++; name++; break;
		case '*':
			if( c=toupper(*++mask), !c)	return 0;
			if( c=='*' || c=='?') break;
			while(*name && toupper(*name)!=c) ++name;
			break;
		default :
			if( c=toupper(*mask++)-toupper(*name++), c ) return c;
		}
	}
	return c;
}

//-----------------------------------------------------------------------------
void	AddFileAsUnwanted( const char* name )
{	UFM*	newmask;
	int	len;
	len = strlen(name);
	newmask = (UFM*)malloc(len+sizeof(UFM));
	newmask->Next = UnwantedFilesList;
	strcpy(newmask->Mask,name);
	UnwantedFilesList = newmask;
}

//-----------------------------------------------------------------------------
void	AddFileToList( const char*	name, short unsigned nDir )
{	char*	ptr;
	DirGrp	*pDirGrp, *pOldGrp;
	FileT* 	Node = NULL;
	FileT*	Old;
	unsigned long	crc = 0xffffffff;

	// pp塞,    䠩 ⥫
	{	UFM	*pMask;
		pMask = UnwantedFilesList;
		while(pMask)
		{	if( !MaskCmp(pMask->Mask,(char*)name) )	return;
			pMask = pMask->Next;
		}
	}

	// ⠥ CRC32
	ptr=(char*)name;
	while(*ptr)	crc = UpdateCrc32((unsigned char)toupper(*ptr++),crc);

	if(Node==NULL)	Node = (FileT*)malloc(sizeof(FileT));
	Node->Key = crc;
	if( Old = (FileT*)file_insert( Node ), Old )
	{	if( //!Old->nDir ||		// 䠩 祭  ⥫  
			Old->nDir == nDir )	return; //  䠩   pp
// ???    뢮  䠩 㯮.
//		cout << name << '\n';
		if( Old->pDirGrp )
		{	unsigned short	*pList, *pOldList;
			unsigned short	i,n;
			pOldGrp = Old->pDirGrp;
			n = (unsigned short)(pOldGrp->nItems+1);
			pDirGrp = GrpLast;
			while( pDirGrp && pDirGrp->Last==nDir )
			{	if( pDirGrp->nItems==n )
				{	pList = pDirGrp->List;
					pOldList = pDirGrp->List;
					for( i=1; i<n && (*pList++ != *pOldList++); i++ );
					if(i==n)	goto grp_found;
				}
				pDirGrp = pDirGrp->Prev;
			}
			//  p㯯  
			if( --(pOldGrp->Count) )
			{	// 稪 ᯮ짮  㫨 => 㦭 ᮧ  p㯯
				pOldList = pOldGrp->List;
				Old->pDirGrp = pDirGrp = (DirGrp*)malloc(sizeof(DirGrp));
				pDirGrp->Count = 1;
				pDirGrp->nItems = n;
				if( n > pOldGrp->nSize )
				{	i = pOldGrp->nPrevSize;
					pDirGrp->nSize = ( i += ( pDirGrp->nPrevSize = pOldGrp->nSize ));
				}else
				{	pDirGrp->nPrevSize = pOldGrp->nPrevSize;
					i = pDirGrp->nSize = pOldGrp->nSize;
				}
				pList = pDirGrp->List = (unsigned short*)malloc( i<<1 );
				for(i=1; i<n; i++ )	*pList++ = *pOldList++;
				*pList = pDirGrp->Last = nDir;
				pDirGrp->nDir = ++nGrp;
				pDirGrp->Next = NULL;
				pDirGrp->Prev = GrpLast;
				( GrpLast ? GrpLast->Next : GrpFirst ) = pDirGrp;
				GrpLast = pDirGrp;
			}else
			{	// 稪 㫨 =>  p㯯 ⮫쪮   ⮣ 䠩
				pOldGrp->Count = 1;
				if( pOldGrp->Next )	// ᫥ p㯯 => p⠢塞  
				{	DirGrp	*p1,*p2;
					p1 = pOldGrp->Next;
					p2 = pOldGrp->Prev;
					( p1 ? p1->Prev : GrpLast ) = p2;
					( p2 ? p2->Next : GrpFirst ) = p1;
					pOldGrp->Next = NULL;
					pOldGrp->Prev = GrpLast;
					( GrpLast ? GrpLast->Next : GrpFirst ) = pOldGrp;
					GrpLast = pOldGrp;
				}
				if( pOldGrp->nSize < n )	//    p ᯨ᪥ p
				{	void*	pMem;
					pMem = pOldList = pOldGrp->List;
					i = pOldGrp->nPrevSize;
					pOldGrp->nSize = (i += (pOldGrp->nPrevSize = pOldGrp->nSize ));
					pList = pOldGrp->List = (unsigned short*)malloc( i<<1 );
					for(i=1; i<n; i++ )	*pList++ = *pOldList++;
					*pList = pOldGrp->Last = nDir;
					free(pMem);
				}else	// p 塞 뫪   pp
				{	pOldGrp->List[n-1] = pOldGrp->Last = nDir;
				}
				pOldGrp->nItems = n;
			}
		}else
		{	pDirGrp = GrpLast;
			while( pDirGrp && pDirGrp->Last==nDir )
			{	if( (pDirGrp->nItems==2) && (*(pDirGrp->List)==Old->nDir) )	goto pair_found;
				pDirGrp = pDirGrp->Prev;
			}
			// p塞  p㯯  2 pp
			Old->pDirGrp = pDirGrp = (DirGrp*)malloc(sizeof(DirGrp));
			pDirGrp->Count = 1;
			pDirGrp->nPrevSize = 1;
			pDirGrp->nSize = 2;
			pDirGrp->nItems = 2;
			pDirGrp->List = (short unsigned*)malloc( 4 );
			*pDirGrp->List = Old->nDir;
			pDirGrp->Last = pDirGrp->List[1] = nDir;
		  	pDirGrp->nDir = ++nGrp;

			pDirGrp->Next = NULL;
			pDirGrp->Prev = GrpLast;
			( GrpLast ? GrpLast->Next : GrpFirst ) = pDirGrp;
			GrpLast = pDirGrp;
		}
		Old->nDir = nDir;
	}else	// ⠪ 䠩   p砫 - ᯥ譮 
	{	nFile++;
		Node->pDirGrp = NULL;
		Node->nDir = nDir;
		Node = NULL;
	}
	return;

grp_found:
	if(!--(pOldGrp->Count) )
	{	// 稪 㫨 => 㤠塞 p DirGrp
		DirGrp *p1,*p2;
		free(pOldGrp->List);
		p1 = pOldGrp->Next;
		p2 = pOldGrp->Prev;
		( p1 ? p1->Prev : GrpLast ) = p2;
		( p2 ? p2->Next : GrpFirst ) = p1;
		free(pOldGrp);
	}
pair_found:
	++(pDirGrp->Count);
	Old->pDirGrp = pDirGrp;
	Old->nDir = nDir;
}
