
#include	<stdlib.h>	// _MAX_PATH exit atoi
#include	<string.h>	// strlen, strcmp, strcpy, strcat
#include	<stdio.h>	// FILE fgets fopen fclose
#include <dos.h>		// _dos_find*
#include <io.h>		// access
#include	<iostream.h>	// cout<<
#include <malloc.h>	// _fmalloc	_ffree
#include	<setjmp.h>	// setjmp longjmp jmp_buf
#include	<sys/stat.h>	// fstat
#include "AddFile.h"	// AddFileToList
#include "DirList.h"

extern jmp_buf	JmpOnError;


DIRNODE* DirListHead;
PSWD*	FirstPswd;
PSWD**pLastPswd;

short unsigned	nDir;
unsigned char	nMaxPswd;
unsigned char	nPswd;

//-----------------------------------------------------------------------------
char* FullPath(char* result, const char* curpath, const char* chdir)
{	char	*ptr,*ptr2;
	int	n;

	if( (*chdir=='\\')|| strchr(chdir,':') )
	{	strcpy(result,chdir);
	}else	if( *chdir=='.' && *(chdir+1)=='.' )
	{	if( result!=curpath )	strcpy( result, curpath );
		n=strlen(result)-1;
		if( result[n]=='\\' ) result[n]='\0';
		ptr2 = (char*)chdir - 1;
		do{
			ptr2++;
			if( ptr=strrchr(result,'\\'), !ptr )	goto Abend;
         *ptr='\0';
			ptr2+=2;
		}while(*ptr2=='\\' && *(ptr2+1)=='.' && *(ptr2+2)=='.' );
		if(*ptr2=='\\')	strcat( result, ptr2 );
	}else
	{	if( result!=curpath )	strcpy( result, curpath );
		n=strlen(result);
		if(result[n-1]!='\\')
		{	result[n++]='\\';
		}
		strcpy(result+n,chdir);
	}
	if( n=strlen(result), n )
	{	if( result[--n]=='\\')
		{	if( result[n-1]!=':' )	result[n]='\0';
		}else	if( result[n++]==':' )
		{	result[n]='\\';
			result[n+1]='\0';
		}
	}
	if( !access( result, R_OK ) )
	{	result[n]='\0';
		return	result;
	}
Abend:
	cout << "Can't set current path to '"<< chdir << "' from '"<< curpath <<"'\n";
	cout << "'"<< result <<"'\n";
	return	NULL;
}


//-----------------------------------------------------------------------------
// p p  ⠡権
char* skip_blanks( char* pstr )
{	if( !pstr )	return NULL;
	while( *pstr==' ' || *pstr=='\t' )	pstr++;
	char c = *pstr;
	if ( !c || c=='\n' || c==';' )	return NULL;
	return pstr;
}

//-----------------------------------------------------------------------------
typedef char* pchar;
static char* NextWord( char* tempbuf, pchar& ptr )
{	char	*p2, *p3, *o, c;
	int	k;

	if( ptr=skip_blanks(ptr), !ptr )	return NULL;
	if( p2 = strchr(ptr,' '), !p2 )	p2 = ptr+strlen(ptr);
	if( p3 = (char*)memchr(ptr,'"',p2-ptr), p3 )
	{	o = tempbuf;
		do{
			if( k = p3-ptr, k )
			{	memcpy(o,ptr,k);
				o += k;
				ptr += k;
			}
			if( p3 = (char*)memchr(++ptr,'"',p3-ptr), !p3 )
			{	cout << "There is no matched qoute\n";
				return NULL;
			}
			if( k = p3-ptr, k )
			{	memcpy(o,ptr,k);
				o += k;
				ptr += k+1;
			}
			if( p2 = strchr(ptr,' '), !p2 )	p2 = ptr+strlen(ptr);
		}while( p3 = (char*)memchr(ptr,'"',p2-ptr), p3 );
		if( k = p2-ptr, k )
		{	memcpy(o,ptr,k);
			o += k;
			ptr += k;
		}
		*o = '\0';
		return o;
	}
	c = *p2;
	*p2 = '\0';
	strcpy(tempbuf,ptr);
	*(ptr = p2) = c;
	return	tempbuf;
}

//-----------------------------------------------------------------------------
void	ReadDirList( const char* pLocCurPath, const char* szFile, byte Flags )
{	FILE*	fileLst;
	char	*ptr,*path;
	char	LocCurPath[_MAX_PATH+1];
	char	listfile[_MAX_PATH2];
	char	tempbuf[_MAX_PATH2];
	char	line[256];

	if( !FullPath(listfile,pLocCurPath,szFile) )	return;
	if( fileLst = fopen( listfile, "rt" ), !fileLst )
	{	cout << "File " << listfile << " could not be opened\n";
		return;
	}
	strcpy(LocCurPath,pLocCurPath);
	while( fgets( line, sizeof(line), fileLst ) )
	{	if( ptr=strchr(line,';' ), ptr )	*ptr='\0';
		else
		{	int k;
			k = strlen(line);
			while( k>0 && line[--k]<=' ' )	line[k]='\0'; // 㡨p CRLF   楢 p
		}
		if(!*line)	continue;
		ptr = line;
		while( path=NextWord(tempbuf,ptr), path )
			AddPathToList( LocCurPath, path, Flags );
	}
	fclose(fileLst);
	return;
}

//-----------------------------------------------------------------------------
static void RecursiveMarkAsDeleted( char* path )
{	char	*ptr;
	DIRNODE*	psrc;
	struct find_t ftdir;

	ptr = path+strlen(path);
	*ptr='*';
	*(ptr+1)='\0';
	if( !_dos_findfirst( path, _A_SUBDIR, &ftdir ) )
	do{
		strcpy( ptr,ftdir.name );
		strupr( ptr );
		if( psrc = gbt_find( DirListHead, path ), psrc )	psrc->Flags |= fDelete;
		RecursiveMarkAsDeleted( path );
		*ptr='*';
		*(ptr+1)='\0';
	}while( !_dos_findnext( &ftdir ) );
#if defined(__OS2__) || defined(__NT__)
	_dos_findclose( &ftdir );
#endif

}

//-----------------------------------------------------------------------------
static void RecursiveAddDir( char* path )
{	char	*ptr;
	DIRNODE	*psrc, *psrc2;
	int	lenpath;
	struct find_t ftdir;
	char	mask[_MAX_PATH];

	lenpath=strlen(path);
	if( path[lenpath-1]!='\\' )
	{	path[lenpath++]='\\';
	   path[lenpath]='\0';
	}
	ptr = path+lenpath;
	strcpy(mask,path);
	mask[lenpath]='*';
	mask[lenpath+1]='\0';
	if( !_dos_findfirst( mask, _A_SUBDIR, &ftdir ) )
	do{
		if( (ftdir.attrib&(_A_SUBDIR|_A_HIDDEN|_A_SYSTEM|_A_VOLID))!=_A_SUBDIR ||
			( *(ftdir.name)=='.' && ( !ftdir.name[1] || ftdir.name[1]=='.' ) ) )	continue;
		psrc = (DIRNODE*)malloc(strlen(ftdir.name)+lenpath+sizeof(DIRNODE));
		strcpy(ptr,ftdir.name);
		strupr(ptr);
		strcpy(psrc->Key,path);
		if( psrc2 = gbt_insert( &DirListHead, psrc ), psrc2 )
		{	free(psrc);
			psrc = psrc2;
		}
		psrc->nPswd = nPswd;
      psrc->Flags = 0;
		RecursiveAddDir( path );
	}while( !_dos_findnext( &ftdir ) );
#if defined(__OS2__) || defined(__NT__)
	_dos_findclose( &ftdir );
#endif
}

//-----------------------------------------------------------------------------
void AddPathToList( char* LocCurPath, const char* szPath, byte Flags )
{	char	*ptr;
	int	len;

	ptr = (char*)szPath;
	len = strlen(szPath);
	while(len)
	{	switch(*ptr)
		{
		case '@':
			ReadDirList(LocCurPath,++ptr,Flags);
		case '\0':
			goto escape;
		case '*':
			Flags |= fRecursive;
			ptr++; len--;
			continue;
		case '!':
			if( strchr(++ptr,'\\') || strchr(ptr,':') )
				cout << "Invalid filename '" << ptr << "'\n";
			else
				AddFileAsUnwanted( ptr );
			goto escape;
		case '+':
			Flags &= 255-fRecursive;
			ptr++; len--;
			continue;
		case '?':
			if(*++ptr)
			{	PSWD*	pPswd;
				if( (nPswd = ++nMaxPswd) > 254 )
				{	cout << "Too many password settings\n";
					goto escape;
				}
				pPswd = (PSWD*)malloc( --len+sizeof(PSWD) );
				pPswd->Next = NULL;
				strcpy( pPswd->Data, ptr );
				*pLastPswd = pPswd;
				pLastPswd = &(pPswd->Next);
			}else	nPswd = 0;
			goto escape;
		case '=':
			FullPath( LocCurPath, LocCurPath, ++ptr );
			goto escape;
		case '^':
			Flags |= fDelete;
			ptr++; len--;
			continue;
		default:
			{	char path[_MAX_PATH2];
				DIRNODE* psrc;
				if( !FullPath( path, LocCurPath, ptr ) )	goto escape;
				psrc = gbt_find( DirListHead, strupr(path) );
				if( Flags & fDelete )
				{	if(psrc)
					{	psrc->Flags |= fDelete;
						if (Flags & fRecursive)	RecursiveMarkAsDeleted( path );
					}
				}else
				{	struct stat	dir_st;
					int	n;
					n = strlen(path);
					if( path[n-1]==':' )	{ path[n]='\\'; path[n+1]='\0'; }
					if( stat( path, &dir_st ) || !S_ISDIR(dir_st.st_mode) )
					{	cout<<"Directory '"<<path<<"' does not exist\n";
						goto escape;
					}
					path[n]='\0';
					if( !psrc )
					{	psrc = (DIRNODE*)malloc(n+sizeof(DIRNODE));
						strcpy(psrc->Key,path);
                  gbt_insert( &DirListHead, psrc );
					}
					psrc->Flags = 0;
					psrc->nPswd = nPswd;
					if( Flags & fRecursive )	RecursiveAddDir( path );
				}
				goto escape;
			}
		}
	}
escape:;
}


void ScanDir( DIRNODE* Node )
{	struct find_t ftfile;
	char	mask[_MAX_PATH2];

	if( Node->Flags & fDelete )	return;
	++nDir;
//	cout << "Scan " << Node->Key <<'\n';	
	_makepath( mask, NULL, Node->Key, "*", NULL );
	if( !_dos_findfirst( mask, _A_NORMAL, &ftfile ) )
	do{
		if( ftfile.attrib & (_A_SUBDIR|_A_HIDDEN|_A_SYSTEM|_A_VOLID) )	continue;
		AddFileToList( ftfile.name, nDir );
	}while( !_dos_findnext( &ftfile ) );
#if defined(__OS2__) || defined(__NT__)
	_dos_findclose( &ftfile );
#endif

}



