#define	VER_NUMBER	"96.11.23"

#include	<stdlib.h>	// _MAX_PATH exit atoi
#include	<stdio.h>	// fgets
#include	<io.h>		// access
#include	<direct.h>	// getcwd
#include	<iostream.h>	// cout<<
#include	<string.h>	//	strcpy strlen memcpy memcmp
#include	<setjmp.h>	// setjmp longjmp jmp_buf
#include	"DirList.h"	//	DirListHead gbt_beat
#include	"AddFile.h"	// FileListHead DirGroupsList

#if defined(__OS2__)
#define VERSION VER_NUMBER"/OS2"
#elif defined(__NT__)
#define VERSION VER_NUMBER"/NT"
//#elif defined(__WINDOWS_386__)
//#define VERSION VER_NUMBER"/WIN386"
#else
#define VERSION VER_NUMBER"/DOS"
#endif

const char szTitle[] = "FastInDeXer "VERSION" - Build Files Database Index\n";

const char szExplain[] =
"\n(c) 1996 Alex Konshin, 2:5030/217, alex@falcon.spb.su"
"\n"
"\nSyntax:"
"\n  FastIDX <index-file> <options and parameters>"
"\n"
"\nOptions:"
"\n -r\trecursion switch on;"
"\n -o\trecursion switch off;"
"\n"
"\nParameter:"
"\n <prefixes><parameter>"
"\n"
"\nPrefixes:"
"\n @\tparameter - file containing parameters list in free format;"
"\n *\trecursion switch on;"
"\n +\trecursion switch off;"
"\n =\tlogical change of current directory;"
"\n ^\tparameter-directory - to delete this directory from scanning scope;"
"\n !\tparameter - unwanted file;"
"\n ?\tparameter - access password;"
"\n default - include specified directory in scope;"
"\n"
;

// 室  p 訡
jmp_buf	JmpOnError;

//-----------------------------------------------------------------------------
int	main ( int argc, char**argv )
{	short int	nArg;
	int	rc = 0;
	char*	output;
	byte Flags;
	char	LocCurPath[PATH_MAX+1];
		
	Flags = 0;
	nDir = 0;
	nGrp = 0;
	nFile = 0;
	GrpFirst = NULL;
	GrpLast = NULL;
	output = NULL;
	FileListHead = NULL;
	DirListHead = NULL;
	FirstPswd = NULL;
	pLastPswd = &FirstPswd;
	nMaxPswd = nPswd = 0;

	cout << szTitle;
	getcwd( LocCurPath, PATH_MAX+1 );

	if( rc=setjmp( JmpOnError ), rc )	goto Abend;	// ⠭ 室  訡

	 /* 権 */
	for( nArg = 1; nArg<argc; nArg++ )
	{  char* psArg;
		psArg = argv[nArg];
		if( *psArg=='/' || *psArg=='-' )
		{	switch( psArg[1] )
			{
			case '?':
			case 'h':
			case 'H':
				cout << szExplain;
				rc = -1;
				goto Abend;
			case 'o':
				Flags &= 255-fRecursive;
				break;
			case 'r':
				Flags |= fRecursive;
				break;
			default:
				cout << "Unknown option " << psArg;
				rc = -2;
				goto	Abend;
			}
			continue;
		}
		if(output)	AddPathToList( LocCurPath, psArg, Flags );
		else
		{	output = psArg;
			cout << "Build directory list\n";
		}
	}
	if( !output ) goto NoOutput;
	if( !DirListHead )	goto NothingToDo;

	cout << "Scan directories\n";
	gbt_beat( DirListHead, ScanDir );
	if ( !nFile )	goto NothingToDo;
	cout << "Scanning complete\n";

	{	DirGrp	*pGrp;
		pGrp	= GrpFirst;
		nGrp = nDir;
		while( pGrp )
		{	pGrp->nDir = ++nGrp;
			pGrp = pGrp->Next;
		}
	}

	cout << "Write index to disk\n";
	if( rc = WriteTreeToFile( output ), !rc )
	{	cout <<'\n'<< nFile << " files\n";
		cout << nDir << " directoies\n";
		cout << nGrp-nDir << " dir groups\n";
	}
Abend:
	return rc;

NothingToDo:
	cout << "Nothing to do\n";
	rc = -4;
	goto Abend;

NoOutput:
	cout << "Output index file is does not specified\n";
	rc = -3;
	goto Abend;
}













