#include	<dos.h>	// _dos_*
#include	<string.h>	// memset strlen strcpy
#include	<iostream.h>	// cout
#include	<errno.h>	// errno
#include	<malloc.h>	// malloc free
#include	<setjmp.h>	// longjmp
#include	"WriteBlk.h"
#include	"DirList.h"
#include	"IDXhead.h"
#include	"AddFile.h"

#define	ITEMBITS		3
#define	MAX_LEVEL	4
#define	LEVELBITS	6
#define	BLKCAPACITY	64
#define	BLKBITS		9
#define	BLKSIZE		512

typedef	struct NEST
{	unsigned long	Key;
	unsigned	long	Data;
}	Nest;
typedef	Nest* pNest;

char*	Pool;
unsigned long	nTail;
unsigned long	OutCounter = 0;
unsigned long*	aDirOffset;
unsigned long*	pOffset;
int	hIdxFile = 0;
unsigned	nLevel;	// ⢮ p
unsigned	iNest[MAX_LEVEL];

jmp_buf	JmpOnErrWrite;

// 뢮 ᯨ᪠ pp  䠩
void write_dirnode_to_file( DIRNODE* node )
{	unsigned l;
	DIRNODE* Safe;
	char*	ptr;

	if( node->Flags & fDelete )	return;

	*pOffset++ = OutCounter;

	OutCounter += l = strlen(node->Key)+2;
	Safe = node->LLINK;	//   p⨬  , ⮬ p 
	*(ptr = node->Key - 1) = node->nPswd;

	if( _dos_write( hIdxFile, (void const*)(ptr), l, &l ) )
	{	node->LLINK = Safe;
		longjmp( JmpOnErrWrite, -11 );
	}
	node->LLINK = Safe;	// ⠭ ᯮp祭
}

//   䠩, 襬   ᯨ᪨ pp  p㯯
int BeforeWriteItems( int nFile, short unsigned nGrp, const char* IdxFileName )
{  unsigned	l;

	//if( IdxFile = _fsopen( IdxFileName, "wb", SH_DENYRW ), IdxFile )
	if( _dos_creat( IdxFileName, _A_NORMAL, &hIdxFile ) )
	{	cout << "Can't create index file " << IdxFileName << '\n';
		return -10;
	}
	{  long unsigned	k;
		k = 1; nLevel = 0;
		nTail = nFile+1;
		while( nTail >= k )
		{	nTail -= k;
			k <<= LEVELBITS;
			iNest[nLevel++]=0;
		};
	}
	Pool = (char*)malloc( ((nDir+1)*3)>(nLevel<<BLKBITS) ? ((nDir+1)*3) : (nLevel<<BLKBITS) );
	pOffset = aDirOffset = (unsigned long*)malloc( (nDir+nGrp+1)<<2 );
	*pOffset++ = 0;
	nLevel--;

	if( setjmp( JmpOnErrWrite ) )	goto Abend;	// ⠭ 室  訡

	// 襬 
	{	IDXheader *pH = (IDXheader*)Pool;
		strcpy(pH->EyeCatcher,"FastIDX");
		pH->nFiles = nFile;
		pH->nPswd = nMaxPswd;
		pH->FormatId = 0;
		pH->FormatVer = 0;
		if( _dos_write( hIdxFile, Pool, sizeof(IDXheader), &l ) )	goto Abend;
	}
	// 뢮 ᯨ᮪ p
	if( nMaxPswd )
	{	PSWD*	pPswd;
		pPswd = FirstPswd;
		while( pPswd )
		{	OutCounter += l = strlen(pPswd->Data)+1;
			if( _dos_write( hIdxFile, (void const*)(pPswd->Data), l, &l ) )	goto Abend;
			pPswd = pPswd->Next;
		}
	}

	// 뢮 ᯨ᮪ pp
	gbt_beat( DirListHead, write_dirnode_to_file );

	// 뢮 ᯨ᮪ p㯯
	{	DirGrp* pGrp;
		char* ptr;
		unsigned short*	pDir;

		pGrp=GrpFirst;
		while( pGrp )
		{	*pOffset++ = OutCounter;
			*Pool = '\0xff';
			*(unsigned short*)(Pool+1) = pGrp->nItems;
			ptr = Pool+3;
			pDir = pGrp->List;
			for(l=0;l<pGrp->nItems;l++,ptr+=3)	*(unsigned long*)ptr = *(aDirOffset+(*pDir++));
			OutCounter += l = (pGrp->nItems+1)*3;
			if( _dos_write( hIdxFile, Pool, l, &l ) )	goto Abend;
			pGrp = pGrp->Next;
		}
	}
	if( l = BLKSIZE-(((unsigned)OutCounter+sizeof(IDXheader))&(BLKSIZE-1)), l )   // 뢠  
	{	memset( Pool, 0, l );
		if( _dos_write( hIdxFile, Pool, l, &l ) ) goto Abend;
	}
	return 0;

Abend:
	cout << "Error "<< errno <<" writting index file\n";
	return -12;
}

//--------------------------------------------------------------------------------------
int AfterWriteItems( void )
{	unsigned int	rc = 0;
	if( hIdxFile )	_dos_close( hIdxFile );
	free(Pool);
	free(aDirOffset);
	return rc;
}

//--------------------------------------------------------------------------------------
int WriteItem( unsigned long Key, short unsigned nDir )
{	unsigned	lvl;
	unsigned	n;

	for(lvl=nLevel; lvl && iNest[lvl]==BLKCAPACITY; lvl--);
	if (!lvl && *iNest==BLKCAPACITY)	goto Abend;

	{	pNest pN;
		pN = (pNest)(Pool+((lvl<<BLKBITS)+(iNest[lvl]<<ITEMBITS)));
		pN->Key = Key;
		pN->Data = aDirOffset[nDir];
	}

	if( lvl==nLevel && nTail && !--nTail )
	{	// 뢮 p맪 - ᠬ ,  p   뢥
		if( n = BLKCAPACITY-(++(iNest[nLevel])), n )
			memset( Pool+((nLevel<<BLKBITS)+(iNest[nLevel]<<ITEMBITS)), 0, n<<ITEMBITS );
		if( _dos_write( hIdxFile, Pool+(nLevel<<BLKBITS), BLKSIZE, &n ) )	goto ErrorWritting;
		nLevel--;
	}else	if( ++(iNest[lvl])==BLKCAPACITY )
	{	if( _dos_write( hIdxFile, Pool+(lvl<<BLKBITS), BLKSIZE, &n ) )	goto ErrorWritting;
	}else
		while( lvl < nLevel )	iNest[++lvl] = 0;

	return 0;

Abend:
	cout << "Programming error\n";
	return -9;

ErrorWritting:
	cout << "Error "<< errno <<" writting index file\n";
	return -13;
}

