// GENERIC_BALANCED_TREE
#include	<string.h>	// strcmp

typedef unsigned char byte;

typedef struct GENERIC_BALANCED_TREE
{	short	unused;
	byte	balance, cmpres;
	struct GENERIC_BALANCED_TREE	*RLINK, *LLINK;
	char	Key[1];
}	GBT;

typedef	void gbt_treate( GBT* node );

extern "C" {
	void* gbt_insert( void** Head, void* New );
	void	gbt_beat( GBT* Root, gbt_treate* func );
	GBT*	gbt_find( GBT* Head, const char* szKey );
}

#define	pLink(p,b)	(GBT**)(void*)((char*)(p)+(b))
#define	Link(p,b)	*pLink(p,b)
#define	Neg(x)	(x^(sizeof(void*)*3))
#define	B(x)	((x)->balance)
#define	A(x)	((x)->cmpres)
#define	N	((GBT*)New)

//   p⭮  ⠭
//#define	Key(x)	((char*)(x)+KeyOffset)
//inline int compare( GBT* x, GBT* y )	{ return strcmp( Key(x), Key(y) ); }
#define compare(x,y)	strcmp( (x)->Key, (y)->Key )

void* gbt_insert( void** Head, void* New )
{
	GBT	*P, *Q, *R, *S, **T, **W;
	unsigned	a;

// A1
	P = S = *(T = (GBT**)Head);
//	A5
	N->LLINK = N->RLINK = NULL;
	B(N) = 0;
	if( P )	goto A2;
// p  ᨬ p
	*T = N;
	return NULL;	
	
A3:if( B(Q) )
	{	T = W; S = Q; }
	P = Q;
A2:
	if( a = compare( N, P ), !a )	return P;
	A(P) = (byte)( a = (a&sizeof(void*))+sizeof(void*) );
	if( Q = *(W = pLink(P,a)), Q )	goto A3;
	*W = Q = N;
// A6
	R = P = Link( S, A(S) );
	while( P!=Q )
		P =Link( P, B(P) = A(P) );
// A7
	if( ( a = A(S) ) != B(S) )
	{	B(S) = (byte)( B(S) ? 0 : (byte)a );	
		return NULL;
	}
	if( B(R) == a )
	{	// A8
		P = R;
		B(R) = B(S) = 0;
		Link( S, a ) = *(W = pLink( R, Neg(a) ));
		*W = S;
	}else
	{	// A9
		P = *(W = pLink( R, Neg(a) ));
		*W = Link( P, a );
		Link( P, a ) = R;
		Link( S, a ) = *(W = pLink( P, Neg(a) ));
		*W = S;
		if( !B(P) )
		{	B(S) = B(R) = 0;
		}else if( B(P) == a )
		{	B(S) = (byte)(a^(sizeof(void*)*3)); B(R) = 0;
		}else
		{	B(S) = 0; B(R) = (byte)a;
		}
		B(P)=0;
	}
// A10
	*T = P;
	return NULL;
}

// 室 p  p浪 p⠭ 祩  맮 㭪樨
typedef	void gbt_treate( GBT* node );

void	gbt_beat( GBT* Root, gbt_treate* func )
{
	GBT*	prev;
	GBT*	cur;
	GBT*	next;

	prev = NULL;
	cur = Root;
GoLeft:
	while ( next = cur->LLINK, next )
	{	cur->cmpres = (byte)8;
		cur->LLINK = prev;
		prev = cur;
		cur = next;
	}
Treate:
	(*func)( cur );
	if( next = cur->RLINK, next )
	{	cur->cmpres = (byte)4;
		cur->RLINK = prev;
		prev = cur;
		cur = next;
		goto	GoLeft;
	}
	do
	{	next = cur;
		if( cur=prev, !cur )	return;
		prev = Link(cur,A(cur));
		Link(cur,A(cur)) = next;
	}while( cur->cmpres == (byte)4 );
	goto	Treate;
}

//  
GBT*	gbt_find( GBT* cur, const char* Key )
{	while( cur )
		switch( strcmp( Key, cur->Key ) )
		{
		case 0:
			return cur;
		case 1:
			cur = cur->RLINK;
			break;
		case -1:
			cur = cur->LLINK;
		}
	return NULL;		
}

