#define	VER_NUMBER	"96.11.23"

#include	<stdlib.h>	// _MAX_PATH
#include	<io.h>	// lseek
#include	<ctype.h>	// toupper
#include	<dos.h>		// _dos_*
#include	<share.h>	// SH_DENYWR
#include	<fcntl.h>	// O_RDONLY
#include	<sys/stat.h>	// stat
#include	<iostream.h>	// cout<<
#include	<malloc.h>	// malloc free
#include	<string.h>	// strcpy strlen memcpy memcmp
#include	"CRC32.h"	// UpdateCrc32
#include	"IDXhead.h"	// IDXheader

#if defined(__OS2__)
#define VERSION VER_NUMBER"/OS2"
#elif defined(__NT__)
#define VERSION VER_NUMBER"/NT"
#else
#define VERSION VER_NUMBER"/DOS"
#endif

enum{ FALSE=0, TRUE=1 };

typedef struct NEST
{       unsigned long   Key;
        unsigned        long    Data;
}       Nest;


const char szTitle[] = "Find In inDeX "VERSION" - Search in index\n";

const char szExplain[] =
	"\n(c) 1996 Alex Konshin, 2:5030/217, alex@falcon.spb.su"
	"\n"
	"\n  FindIDX <index file> <target file>"
	"\n";

#define	ITEMBITS		3
#define	MAX_LEVEL	4
#define	LEVELBITS	6
#define	BLKCAPACITY	64
#define	BLKBITS		9
#define	BLKSIZE		512

void SayDirectory( const char* pDirList, char* ptr )
{	unsigned char n;
	n = *ptr++;
	cout << ptr;	// 뢮 pp
	if( n )
	{	ptr = (char*)pDirList;
		while(--n)	ptr = strchr(ptr,'\0')+1;
		cout << " | " << ptr;	// 뢮 p
	}
	cout << '\n';
}


//-----------------------------------------------------------------------------
int	main ( int argc, char**argv )
{
	char*	ptr;
	char*	pDirList;
	char*	pBlk;
	Nest*	pNest;
	unsigned long crc = 0xffffffff;
	unsigned	long	nFile;
	unsigned	long	FileSize, nSize;
	unsigned	long	nDisp;	// ᬥ饭 p -⮬  砫 䠩
	unsigned	long	nSeek;	// ᬥ饭 , p 㤥 
	IDXheader	Header;
	int	hIdx, rc=0;
	unsigned l;
	unsigned long	LvlCapacity[MAX_LEVEL];
	unsigned short	LvlBits;
	unsigned	short nLevel;

//	char	target[_MAX_PATH2];

	if (argc<3)
	{	cout << szTitle << szExplain;
		return -1;
	}

	ptr=(char*)argv[2];
	while(*ptr)     crc = UpdateCrc32((unsigned char)toupper(*ptr++),crc);

	if( _dos_open( argv[1], O_RDONLY|SH_DENYWR, &hIdx ) )
	{	cout << "Can't open index file '"<<argv[1]<<"'\n";
		return -2;
	}
	{	struct stat st;
		if( fstat( hIdx, &st ) )
		{	cout << "Can't obtain stat information\n";
			return -2;
		}
		FileSize = st.st_size;
		if( FileSize&(BLKSIZE-1)|| FileSize < BLKSIZE )	goto	InvalidFormat;
	}
	// ⠥ 
	if( _dos_read( hIdx,(void*)&Header, sizeof(IDXheader), &l) || l!=sizeof(IDXheader) )
		goto ErrorReadingFile;
	// pp塞 p p
	if( Header.FormatId!=0 || Header.FormatVer>0 )
		goto	UnsupportedIndexFormat;

	nFile = Header.nFiles;	// ⢮ ⮢  

	{	// 樠p㥬 ⠡  p   p塞 ⢮ p
		unsigned long k = 1,n = 1;
		nLevel = 0;
		do{
			LvlCapacity[nLevel++] = n;
			n +=  (k <<= LEVELBITS);
		}while( nFile > n );
		nLevel--;
	}


	nSize = ((nFile<<ITEMBITS)+(BLKSIZE-1)) & (long)(-BLKSIZE);
	nDisp = FileSize - nSize;
//cout << "crc="<<crc<<",nFile="<<nFile<<", FileSize="<<FileSize<<", nLevel =" << nLevel <<'\n';
	pBlk = (pDirList = (char*)malloc(nDisp-sizeof(IDXheader)+BLKSIZE)) + nDisp-sizeof(IDXheader);
	if( _dos_read( hIdx,pDirList, nDisp-sizeof(IDXheader), &l ) )		goto ErrorReadingFile;

	{	unsigned long	LvlCap, LvlCap1; // ⨬ p ⥪饣  襣 p
		unsigned long	nItemsInCurBlk;	// ⢮ ⮢  ⥪饬 
		unsigned long	Item;	// p   ⥪饬 
//		unsigned	long	nDisp;	// ᬥ饭 p -⮬  砫 䠩
//		unsigned	long	nSeek;	// ᬥ饭 , p 㤥 
		unsigned long nNonFull;	// p  p:
				//   -    p nLevel-1, ᫥ -  nLevel-2
		char	bFull = FALSE;

		LvlBits = (unsigned short)(nLevel*LEVELBITS);
		LvlCap1 = LvlCapacity[nLevel];
		nSeek = FileSize - BLKSIZE;
		nItemsInCurBlk = ( nFile >= BLKCAPACITY ? BLKCAPACITY : nFile );	
		// 横 ᪠
		while(nFile)
		{
//cout << "nFile=" << nFile << ", nSeek =" << nSeek << ", nDisp="<<nDisp<<'\n';
			if( lseek( hIdx, nSeek, SEEK_SET )==0xffffffff
				|| _dos_read( hIdx, pBlk, BLKSIZE, &l ) )	goto ErrorReadingFile;
			// 横 ᪠  
			//   , ⮬ ᤥ  .
//cout << "[0]="<<((Nest*)pBlk)->Key<<",["<<(nItemsInCurBlk-1)<<"]="<< (((Nest*)pBlk)+nItemsInCurBlk-1)->Key <<'\n';

			for( pNest = (Nest*)pBlk, Item = 0; Item<nItemsInCurBlk && pNest->Key <= crc; Item++, pNest++)
				if( pNest->Key == crc )	goto Found;
			if( Item==nItemsInCurBlk || !nLevel )	goto NotFound;

			// 塞 ᫥騩   뢠  ᪠  
			LvlCap = LvlCap1;
			LvlCap1 = LvlCapacity[--nLevel];
//cout << "Item=" << Item <<", LvlCap="<<LvlCap<<", LvlCap1="<<LvlCap1<<", LvlBits="<<LvlBits<<'\n';
//cout << "nNonFull=" << ((nFile-LvlCap1)>>LvlBits)-1 <<'\n';
			if( !bFull && (nNonFull = ((nFile-LvlCap1)>>LvlBits)-1, Item >= nNonFull) )
			{	if( Item == nNonFull )
				{	nSeek -= ( ( nLevel ? LvlCapacity[nLevel-1]*(nItemsInCurBlk-Item-1)+1 : 1 )<<BLKBITS );
					nDisp += ((LvlCap1*Item)<<BLKBITS);
					nFile -= (Item+1)*(LvlCap-LvlCap1);
					nItemsInCurBlk = ( nFile >= BLKCAPACITY ? BLKCAPACITY : nFile );	
				}else
				{	if( !nLevel ) goto NotFound;
					LvlCap = LvlCap1;	//  p
					LvlCap1 = LvlCapacity[--nLevel];
					nDisp = nSeek - ((LvlCap1*(nItemsInCurBlk-Item))<<BLKBITS);
					nSeek = nDisp + ((LvlCap1-1)<<BLKBITS);
					bFull = TRUE;
					nFile = LvlCap-1;
				}
			}else	//  p
			{	nDisp += ((LvlCap1*Item)<<BLKBITS);
				nSeek = nDisp+((LvlCap1-1)<<BLKBITS);
				bFull = TRUE;
				nFile = LvlCap-1;
			}
			LvlBits -= LEVELBITS;
		}
	
NotFound:
		cout << "Not Found\n";
		goto Finish;
	}

Found:
	cout << "Found\n\n";
	ptr= pDirList + pNest->Data;
	if( *ptr=='0xff' )
	{	unsigned short	n;
		rc = n = *(unsigned short*)(ptr+1);
		do{
			ptr+=3;
			SayDirectory( pDirList, pDirList+((*(unsigned long*)ptr)&0x00ffffff) );
		}while( --n );
	}else
	{	SayDirectory( pDirList, ptr );
		rc = 1;
	}

Finish:
	free(pDirList);
	_dos_close(hIdx);
	return rc;

ErrorReadingFile:
	cout << "Error reading index file '"<<argv[1]<<"'\n";
	rc = -3;
	goto Finish;

InvalidFormat:
	cout << "Invalid format of index file\n";
	rc = -4;
	goto Finish;
UnsupportedIndexFormat:
	cout << "Unsupported format\n";
	rc = -4;
	goto Finish;
}

